package com.zipcodewilmington.bankaccountlab;

/**
 * Created by leon on 1/10/18.
 */
public abstract class BankAccount {

    protected String accountHolder;
    private int accountNumber;
    private double accountBalance;
    private short PIN;

    public BankAccount(String accountHolder, int accountNumber, short PIN) {
        this.accountHolder = accountHolder;
        this.accountNumber = accountNumber;
        this.accountBalance = 0;
        this.PIN = PIN;
    }

    public short getPIN() {
        return PIN;
    }

    public Integer getAccountNumber() {
        return accountNumber;

    }

    public Double getAccountBalance() {
        return accountBalance;
    }

    public String getAccountHolder() {
        return accountHolder;
    }

    public void credit(double creditAmount) {
        accountBalance += creditAmount;
    }

    public void debit(double debitAmount) {
        accountBalance -= debitAmount;
    }

    public abstract String getAccountSummary();



}
