package com.zipcodewilmington.bankaccountlab;

import java.util.Scanner;

/**
 * Created by leon on 1/10/18.
 */
public class MainApplication {

    public static void main(String[] args) {
        ATM atm = new ATM();
        Scanner input = new Scanner(System.in);

        BankAccount checkingAccount = new CheckingAccount("Arya Stark", 12345, (short)1234);
        BankAccount businessAccount = new BusinessAccount("Ned Stark", "Winterfell Snowglobe Inc.", 23456, (short) 1234);
        BankAccount savingsAccount = new SavingsAccount("Daenerys Targaryen", 34567, (short)1234);

        checkingAccount.credit(540.00);
        businessAccount.credit(150000.00);
        savingsAccount.credit(10000000.00);

        atm.addAccount(checkingAccount);
        atm.addAccount(businessAccount);
        atm.addAccount(savingsAccount);

        while (true) {

            System.out.println("Hello! This is an ATM");
            System.out.println("What is the number of the account you'd like to access?");
            int accountNumber = input.nextInt();
            input.nextLine();
            BankAccount account = atm.accessAccount(accountNumber);

            System.out.println("What would you like to do?");
            System.out.println("(you can credit, debit, or get balance)");
            System.out.println("(when you're done, say exit)");

            String action = input.nextLine();

            if (action.equalsIgnoreCase("credit")) {
                System.out.println("How much would you like to deposit? ");
                double amount = input.nextDouble();
                input.nextLine();
                account.credit(amount);
                System.out.println(account.getAccountSummary());
            }
            else if (action.equalsIgnoreCase("debit")) {
                System.out.println("How much would you like to take out? ");
                double amount = input.nextDouble();
                input.nextLine();
                account.debit(amount);
                System.out.println(account.getAccountSummary());
            }
            else if (action.equalsIgnoreCase("balance")) {
                System.out.println(account.getAccountSummary());
            }
            else if (action.equalsIgnoreCase("exit")) {
                break;
            }
        }

    }





}
