package com.zipcodewilmington.bankaccountlab;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import java.util.Arrays;

/**
 * Created by leon on 1/10/18.
 */
public class BankAccountTest {

    @Test
    public void businessAccountTest1() {
        BankAccount businessAccount = new BusinessAccount("The Man In Black", "WestWorld", 1234567, (short) 1234);

        String expected = "The Man In Black";
        String actual = businessAccount.getAccountHolder();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void businessAccountTest2() {
        BankAccount businessAccount = new BusinessAccount("The Man In Black", "WestWorld", 1234567, (short) 1234);

        String expected = "WestWorld";
        String actual = ((BusinessAccount) businessAccount).getBusinessName();

        Assertions.assertEquals(expected, actual);


        Arrays.sort(new String[] {"a", "b", "c"});
    }
    @Test
    public void businessAccountTest3() {
        BankAccount businessAccount = new BusinessAccount("The Man In Black", "WestWorld", 1234567, (short) 1234);

        String expected = "Business Account: WestWorld | Balance: 0.0";
        String actual = businessAccount.getAccountSummary();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void checkingAccountTest() {
        BankAccount checkingAccount = new CheckingAccount("The Man In Black", 98765432, (short) 1234);

        String expected = "Checking Account: The Man In Black | Balance: 0.0";
        String actual = checkingAccount.getAccountSummary();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void savingsAccountTest() {
        BankAccount savingsAccount = new SavingsAccount("The Man In Black", 98765432, (short) 1234);

        String expected = "Savings Account: The Man In Black | Balance: 0.0";
        String actual = savingsAccount.getAccountSummary();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void getAccountHolderTest() {
        BankAccount checkingAccount = new CheckingAccount("The Man In Black", 98765432, (short) 1234);

        String expected = "The Man In Black";
        String actual = checkingAccount.getAccountHolder();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void getAccountBalanceTest() {
        BankAccount checkingAccount = new CheckingAccount("The Man In Black", 98765432, (short) 1234);

        double expected = 0.0;
        double actual = checkingAccount.getAccountBalance();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void creditTest() {
        BankAccount checkingAccount = new CheckingAccount("The Man In Black", 98765432, (short) 1234);
        checkingAccount.credit(54.0);
        double expected = 54.0;
        double actual = checkingAccount.getAccountBalance();

        Assertions.assertEquals(expected, actual);
    }
    @Test
    public void debitTest() {
        BankAccount checkingAccount = new CheckingAccount("The Man In Black", 98765432, (short) 1234);
        checkingAccount.credit(60.0);
        checkingAccount.debit(20.0);
        double expected = 40.0;
        double actual = checkingAccount.getAccountBalance();

        Assertions.assertEquals(expected, actual);

    }


}
